package org.seasar.dao.annotation.impl;

import java.lang.reflect.Method;

import org.seasar.dao.annotation.Arguments;
import org.seasar.dao.annotation.DaoAnnotationReader;
import org.seasar.dao.annotation.NoPersistentProperty;
import org.seasar.dao.annotation.PersistentProperty;
import org.seasar.dao.annotation.Query;
import org.seasar.dao.annotation.S2Dao;
import org.seasar.framework.beans.BeanDesc;
import org.seasar.framework.beans.factory.BeanDescFactory;

public class JDK5DaoAnnotationReader implements DaoAnnotationReader {
	private Class daoClass_;
	private BeanDesc daoBeanDesc_;
	
	public JDK5DaoAnnotationReader(Class daoClass) {
		daoClass_ = daoClass;
		daoBeanDesc_ = BeanDescFactory.getBeanDesc(daoClass);
	}

	public String[] getArgNames(String methodName) {
		Method[] methods = daoBeanDesc_.getMethods(methodName);
		if(methods==null || methods.length!=1){
			return new String[0];			
		}
		Method method = methods[0];
		Arguments arguments = method.getAnnotation(Arguments.class);
		if(arguments!=null){
			return arguments.value();
		}else{
			return new String[0];
		}
	}

	public String getQuery(String methodName) {
		Method[] methods = daoBeanDesc_.getMethods(methodName);
		if(methods==null || methods.length!=1){
			return null;			
		}
		Method method = methods[0];
		Query query = method.getAnnotation(Query.class);
		if(query!=null){
			return query.value();
		}else{
			return null;
		}
	}
	public String[] getNoPersistentProperty(String methodName) {
		Method[] methods = daoBeanDesc_.getMethods(methodName);
		if(methods==null || methods.length!=1){
			return null;			
		}
		Method method = methods[0];
		NoPersistentProperty props = method.getAnnotation(NoPersistentProperty.class);
		if(props!=null){
			return props.value();
		}else{
			return null;
		}
	}
	public String[] getPersistentProperty(String methodName) {
		Method[] methods = daoBeanDesc_.getMethods(methodName);
		if(methods==null || methods.length!=1){
			return null;			
		}
		Method method = methods[0];
		PersistentProperty props = method.getAnnotation(PersistentProperty.class);
		if(props!=null){
			return props.value();
		}else{
			return null;
		}
	}
	
	public Class getBeanClass() {
		S2Dao daoAnnotation = (S2Dao) daoClass_.getAnnotation(S2Dao.class);
		return daoAnnotation.bean();
	}
}
