package test.org.seasar.dao.impl;

import java.util.List;

import org.seasar.dao.annotation.Arguments;
import org.seasar.dao.annotation.NoPersistentProperty;
import org.seasar.dao.annotation.PersistentProperty;
import org.seasar.dao.annotation.Query;
import org.seasar.dao.annotation.S2Dao;
@S2Dao(bean=Employee.class)
public interface EmployeeAutoDao {

	@Arguments("deptno")
	public List getEmployeeByDeptno(int deptno);
	
	@Query("sal BETWEEN ? AND ? ORDER BY empno")
	public List getEmployeesBySal(Float minSal, Float maxSal);
	
	@Arguments({"enames","jobs"})
	@Query("ename IN /*enames*/('SCOTT','MARY') AND job IN /*jobs*/('ANALYST', 'FREE')")
	public List getEmployeesByEnameJob(List enames, List jobs);
	
	public List getEmployeesBySearchCondition(EmployeeSearchCondition dto);
	
	public List getEmployeesByEmployee(Employee dto);
	
	@Arguments("empno")
	public Employee getEmployee(int empno);

	public void insert(Employee employee);
	
	@NoPersistentProperty({"job","mgr", "hiredate", "sal", "comm", "deptno"})
	public void insert2(Employee employee);
	
	@PersistentProperty("deptno")
	public void insert3(Employee employee);
	
	public void insertBatch(Employee[] employees);
	
	public void update(Employee employee);
	
	@NoPersistentProperty({"job","mgr", "hiredate", "sal", "comm", "deptno"})
	public void update2(Employee employee);
	
	@PersistentProperty("deptno")
	public void update3(Employee employee);
	
	public void updateBatch(Employee[] employees);
	
	public void delete(Employee employee);
	
	public void deleteBatch(Employee[] employees);
}
